
import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';

import { map } from 'rxjs/operators';
import { environment } from 'src/environments/environment';
import { InfosUser } from '../models/InfosUser';
import { Jwt } from '../models/jwt';

@Injectable({
  providedIn: 'root',
})
export class AuthentificationService {
  private controller  = "admin/Token";
  private apiUrl = environment.apiUrl;
  private httpOptions = {
    headers: new HttpHeaders({
      'Authorization' : 'Bearer ' + localStorage.getItem('access_token'),
      'Access-Control-Allow-Headers': 'Content-Type',
      'Access-Control-Allow-Origin': '*'
    }),
  };

  constructor(private http: HttpClient) {
  }


  public accessToken(userId:string, userRole: string): Observable<any> {
    return this.http
      .post<Jwt>(this.apiUrl + this.controller + '?userId='+ userId + '&userRole=' + userRole ,this.httpOptions)
      .pipe(map((reponse) =>  reponse)); 
  }

  public obtenirUser(userId:string): Observable<InfosUser> {
    return this.http
      .get<InfosUser>(this.apiUrl + 'admin/InfosUser' + '?userId='+ Number.parseInt(userId) ,this.httpOptions)
      .pipe(map((reponse) => reponse)); 
  }

  public refreshToken(jwt: Jwt): Observable<Jwt> {
    return this.http
      .post<Jwt>(this.apiUrl + this.controller, jwt,this.httpOptions)
      .pipe(map((reponse) => reponse )); 
  }

}
